/*
** JabberX (Jabber Client)
** Copyright (c) 1999-2001 Gurer Ozen <palpa@jabber.org>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** browsing
*/

#include "common.h"


void cmd_browse(char *arg)
{
	iks *x;
	char *to;

	if(arg)
		to = arg;
	else
		to = net.id->server;

	x = iks_make_iq(IKS_TYPE_GET, IKS_NS_BROWSE);
	iks_insert_attrib(x, "to", to);
	iks_send(net.parser, x);
	iks_delete(x);
}


void browse_parse(ikspak *pak)
{
	iks *x;

	gui_attr(GA_NOTICE);

	x = iks_child(pak->x);
	gui_print("Browse result of '%s':\n", iks_id_print(pak->from));
	gui_print("%s (%s) [%s/%s]\n", iks_find_attrib(x, "name"), iks_find_attrib(x, "jid"), 
		  iks_name(x), iks_find_attrib(x, "type"));

	x = iks_child(x);
	while(x)
	{
		if(iks_type(x) == IKS_TAG)
		{
			if(iks_strcmp(iks_name(x), "ns") == 0)
				gui_print("'%s' namespace supported.\n", iks_cdata(iks_child(x)));
			else
				gui_print("-> %s (%s) [%s/%s]\n", iks_find_attrib(x, "name"),
					  iks_find_attrib(x, "jid"),
					  iks_name(x), iks_find_attrib(x, "type"));
		}

		x = iks_next(x);
	}
}
