#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <iksemel.h>
#include "common.h"
#include "config.h"

#ifndef HAVE_STRSEP
char *strsep(char **stringp, const char *delim);
#endif

#ifndef PKGDATADIR
#error no PKGDATADIR defined!
#endif
#define HELPFILE PKGDATADIR "/inprogram.help"


void cmd_help(char *arg) {
	iks *x,*y,*z,*u;
	char *r,*t;
	enum gattrs a;
	int f,i,w;
	struct stat s;

	if( !(((stat( HELPFILE , &s)) == 0) && S_ISREG(s.st_mode)) )  
	{
		gui_xprint(UIF_NEWLINE|UIF_EXTRANL|UIF_SETATTR,GA_SYSMSG,"Could not stat helpfile %s",HELPFILE);
		return;
	}

	r = arg; t = arg;
	x = iks_load( HELPFILE );
	y = x;

	if( !x )  
	{
		gui_xprint(UIF_NEWLINE|UIF_EXTRANL|UIF_SETATTR,GA_SYSMSG,"Error reading helpfile %s",HELPFILE);
		return;
	}

	while( (t = strsep(&r," \t")) && *t ) 
	{
		z = iks_child(y);
		while(t && *t) 
		{
			while( z ) 
			{
				if( iks_strcasecmp(iks_name(z),"item")==0 && iks_strcasecmp(iks_find_attrib(z,"topic"),t)==0 ) 
				{
					t = iks_find_attrib(z,"alias");
					if( !t ) 
						y = z;
					
					z = iks_child(y);
					break;
				}
				z = iks_next(z);
			}

			if( !z) 
			{
				gui_xprint(UIF_NEWLINE|UIF_SETATTR,GA_SYSMSG,"No such helpitem: %s",t);
				return;
			}
		}
	}
	w = (ui_w - 1 ) / 15 ;
	if( w<=0 ) w = 1;
	if( !y ) 
		return;
	else
	{
		i = 0;
		z = iks_child(y);
		while( z ) {
			if(iks_type(z) == IKS_TAG) {
				a = GA_MENU;
				f = UIF_STRIPNL | UIF_SETATTR;
				if( iks_strcasecmp(iks_name(z),"item") == 0 ) {
					if( i <= 0 ) {
						gui_xprint(UIF_SETATTR|UIF_NEWLINE,GA_MENU,"Available subtopics:");
						i = 0;
					}
					i++;
					gui_xprint(((i%w == 0 )?UIF_NEWLINE:UIF_NORMAL),0,"%-12s   ",iks_find_attrib(z,"topic"));
					z = iks_next(z);
					continue;
				}
				if( iks_strcasecmp(iks_name(z),"p") == 0 ) {
					f |= UIF_NEWLINE;
				}
				if( (t= iks_find_attrib(z,"mode") )) {
					a = atoi(t);
				}
				u = iks_child(z);
				while( u && iks_type(u) != IKS_CDATA ) {
					u = iks_next(u);
				}
				if( u && (t = iks_cdata(u) ) ){
					if( i > 0 ) {
						gui_print("\n\n");
						i = 0;
					}
					gui_xprint(f,a,"%s",t);
				}
			}
			z = iks_next(z);
		}
	}
	iks_delete(x);
}
